win11_theme = {
    "window": {
        "back": "#f4f4f4"
    },

    "label": {
        "back": "transparent",
        "text_back": "#000000",
    },

    "button": {
        "radius": 13,
        "back": "#fdfdfd",
        "border": "#ededed",
        "text_back": "#202020",
        "border_width": 1,

        "active": {
            "back": "#f9f9f9",
            "border": "#d5d5d5",
            "text_back": "#202020",
            "border_width": 1,
        },

        "pressed": {
            "back": "#fafafa",
            "border": "#ebebeb",
            "text_back": "#202020",
            "border_width": 1,
        },
    },

    "frame": {
        "radius": 15,
        "back": "#fafafa",
        "border": "#e7e7e7",
        "border_width": 2,
    },

    "entry": {
        "radius": 13,
        "padding": (8, 8),

        "back": "#fdfdfd",
        "border": "#ebebeb",
        "text_back": "#18191c",
        "border_width": 1,

        "bottom_line": "#8a8a8a",
        "bottom_width": 1,

        "focusin": {
            "back": "#ffffff",
            "border": "#ebebeb",
            "text_back": "#18191c",
            "border_width": 1,

            "bottom_line": "#005fb8",
            "bottom_width": 2,
        }
    },

    "text": {
        "radius": 13,
        "padding": (8, 8),

        "back": "#fdfdfd",
        "border": "#ebebeb",
        "text_back": "#18191c",
        "border_width": 1,

        "bottom_line": "#8a8a8a",
        "bottom_width": 1,

        "focusin": {
            "back": "#ffffff",
            "border": "#ebebeb",
            "text_back": "#18191c",
            "border_width": 1,

            "bottom_line": "#005fb8",
            "bottom_width": 2,
        }
    },

    "separator": {
        "back": "#d0d0d0",
        "border_width": 1,

        "rounded": True
    }
}

win11_dark_theme = {
    "window": {
        "back": "#202020"
    },

    "label": {
        "back": "transparent",
        "text_back": "#ffffff",
    },

    "button": {
        "radius": 13,
        "back": "#2a2a2a",
        "border": "#313131",
        "text_back": "#ebebeb",
        "border_width": 1,

        "active": {
            "back": "#2f2f2f",
            "border": "#313131",
            "text_back": "#ebebeb",
            "border_width": 1,
        },

        "pressed": {
            "back": "#232323",
            "border": "#2c2c2c",
            "text_back": "#ebebeb",
            "border_width": 1,
        },
    },

    "frame": {
        "radius": 15,
        "back": "#1c1c1c",
        "border": "#2f2f2f",
        "border_width": 2,
    },

    "entry": {
        "radius": 13,
        "padding": (8, 8),

        "back": "#292929",
        "border": "#292929",
        "text_back": "#e7e9eb",
        "border_width": 1,

        "bottom_line": "#989898",
        "bottom_width": 1,

        "focusin": {
            "back": "#1c1c1c",
            "border": "#2c2c2c",
            "text_back": "#e7e9eb",
            "border_width": 1,

            "bottom_line": "#57c8ff",
            "bottom_width": 2,
        }
    },

    "text": {
        "radius": 13,
        "padding": (8, 8),

        "back": "#292929",
        "border": "#292929",
        "text_back": "#e7e9eb",
        "border_width": 1,

        "bottom_line": "#989898",
        "bottom_width": 1,

        "focusin": {
            "back": "#1c1c1c",
            "border": "#2c2c2c",
            "text_back": "#e7e9eb",
            "border_width": 1,

            "bottom_line": "#57c8ff",
            "bottom_width": 2,
        }
    },

    "separator": {
        "back": "#404040",
        "border_width": 1,

        "rounded": True
    }
}

gtk_theme = {
    "window": {
        "back": "#ffffff"
    },

    "label": {
        "back": "transparent",
        "text_back": "#000000",
    },

    "button": {
        "radius": 11,
        "back": "#f6f5f4",
        "border": "#ccc6c1",
        "text_back": "#2e3436",
        "border_width": 1.3,

        "active": {
            "back": "#f8f8f7",
            "border": "#dad6d2",
            "text_back": "#2e3436",
            "border_width": 1.3,
        },

        "pressed": {
            "back": "#dad6d2",
            "border": "#dad6d2",
            "text_back": "#2e3436",
            "border_width": 1.3,
        },
    },

    "frame": {
        "radius": 0,
        "back": "#f6f5f4",
        "border": "#d5d0cc",
        "border_width": 2,
    },

    "entry": {
        "radius": 11,
        "padding": (5, 5),

        "back": "#ffffff",
        "border": "#cdc7c2",
        "text_back": "#000000",
        "border_width": 1,

        "bottom_line": "#eaeaea",
        "bottom_width": 0,

        "focusin": {
            "back": "#ffffff",
            "border": "#3584e4",
            "text_back": "#000000",
            "border_width": 1,

            "bottom_line": "#185fb4",
            "bottom_width": 0,
        }
    },

    "text": {
        "padding": (5, 5),

        "radius": 0,
        "back": "#ffffff",
        "border": "#cdc7c2",
        "text_back": "#000000",
        "border_width": 1,

        "bottom_line": "#eaeaea",
        "bottom_width": 0,

        "focusin": {
            "back": "#ffffff",
            "border": "#3584e4",
            "text_back": "#000000",
            "border_width": 1,

            "bottom_line": "#185fb4",
            "bottom_width": 0,
        }
    },

    "separator": {
        "back": "#d8d4d0",
        "border_width": 1,

        "rounded": True
    }
}

gtk_dark_theme = {
    "window": {
        "back": "#353535"
    },

    "label": {
        "back": "transparent",
        "text_back": "#ffffff",
    },

    "button": {
        "radius": 11,
        "back": "#353535",
        "border": "#1b1b1b",
        "text_back": "#eeeeec",
        "border_width": 1.3,

        "active": {
            "back": "#373737",
            "border": "#1b1b1b",
            "text_back": "#eeeeec",
            "border_width": 1.3,
        },

        "pressed": {
            "back": "#1e1e1e",
            "border": "#282828",
            "text_back": "#eeeeec",
            "border_width": 1.3,
        },
    },

    "frame": {
        "radius": 0,
        "back": "#313131",
        "border": "#1b1b1b",
        "border_width": 2,
    },

    "entry": {
        "radius": 11,
        "padding": (5, 5),

        "back": "#2d2d2d",
        "border": "#1f1f1f",
        "text_back": "#cccccc",
        "border_width": 1,

        "bottom_line": "#eaeaea",
        "bottom_width": 0,

        "focusin": {
            "back": "#2d2d2d",
            "border": "#3584e4",
            "text_back": "#ffffff",
            "border_width": 1,

            "bottom_line": "#3584e4",
            "bottom_width": 0,
        }
    },

    "text": {
        "padding": (5, 5),

        "radius": 0,
        "back": "#2d2d2d",
        "border": "#1f1f1f",
        "text_back": "#cccccc",
        "border_width": 1,

        "bottom_line": "#eaeaea",
        "bottom_width": 0,

        "focusin": {
            "back": "#2d2d2d",
            "border": "#3584e4",
            "text_back": "#ffffff",
            "border_width": 1,

            "bottom_line": "#3584e4",
            "bottom_width": 0,
        }
    },

    "separator": {
        "back": "#282828",
        "border_width": 1,

        "rounded": True
    }
}

bilibili_theme = {
    "window": {
        "back": "#ffffff"
    },

    "label": {
        "back": "transparent",
        "text_back": "#000000",
    },

    "button": {
        "radius": 16,
        "back": "#ffffff",
        "border": "#e3e5e7",
        "text_back": "#18191c",
        "border_width": 1,

        "active": {
            "back": "#e3e5e7",
            "border": "#e3e5e7",
            "text_back": "#18191c",
            "border_width": 1,
        },

        "pressed": {
            "back": "#eceff0",
            "border": "#e3e5e7",
            "text_back": "#6d7479",
            "border_width": 1,
        },
    },

    "frame": {
        "radius": 18,
        "back": "#f6f7f8",
        "border": "#f1f2f3",
        "border_width": 2,
    },

    "entry": {
        "radius": 16,
        "padding": (8, 8),

        "back": "#ffffff",
        "border": "#e3e5e7",
        "text_back": "#18191c",
        "border_width": 1,

        "bottom_line": "#eaeaea",
        "bottom_width": 0,

        "focusin": {
            "back": "#ffffff",
            "border": "#ff6699",
            "text_back": "#18191c",
            "border_width": 1,

            "bottom_line": "#185fb4",
            "bottom_width": 0,
        }
    },

    "text": {
        "radius": 16,
        "padding": (8, 8),

        "back": "#ffffff",
        "border": "#e3e5e7",
        "text_back": "#18191c",
        "border_width": 1,

        "bottom_line": "#eaeaea",
        "bottom_width": 0,

        "focusin": {
            "back": "#ffffff",
            "border": "#ff6699",
            "text_back": "#18191c",
            "border_width": 1,

            "bottom_line": "#185fb4",
            "bottom_width": 0,
        }
    },

    "separator": {
        "back": "#f1f2f3",
        "border_width": 1,

        "rounded": True
    }
}

bilibili_dark_theme = {
    "window": {
        "back": "#17181a"
    },

    "label": {
        "back": "transparent",
        "text_back": "#ffffff",
    },

    "button": {
        "radius": 16,
        "back": "#242628",
        "border": "#2f3134",
        "text_back": "#dcdee0",
        "border_width": 1,

        "active": {
            "back": "#2f3134",
            "border": "#2f3134",
            "text_back": "#dcdee0",
            "border_width": 1,
        },

        "pressed": {
            "back": "#26282a",
            "border": "#2f3134",
            "text_back": "#a9abad",
            "border_width": 1,
        },
    },

    "frame": {
        "radius": 18,
        "back": "#1e2022",
        "border": "#232527",
        "border_width": 2,
    },

    "entry": {
        "radius": 16,
        "padding": (8, 8),

        "back": "#17181a",
        "border": "#2f3134",
        "text_back": "#e7e9eb",
        "border_width": 1,

        "bottom_line": "#eaeaea",
        "bottom_width": 0,

        "focusin": {
            "back": "#17181a",
            "border": "#d44e7d",
            "text_back": "#e7e9eb",
            "border_width": 1,

            "bottom_line": "#d44e7d",
            "bottom_width": 0,
        }
    },

    "text": {
        "radius": 16,
        "padding": (8, 8),

        "back": "#17181a",
        "border": "#2f3134",
        "text_back": "#e7e9eb",
        "border_width": 1,

        "bottom_line": "#eaeaea",
        "bottom_width": 0,

        "focusin": {
            "back": "#17181a",
            "border": "#d44e7d",
            "text_back": "#e7e9eb",
            "border_width": 1,

            "bottom_line": "#d44e7d",
            "bottom_width": 0,
        }
    },

    "separator": {
        "back": "#232527",
        "border_width": 1,

        "rounded": True
    }
}

metro_theme = {
    "window": {
        "back": "#ffffff"
    },

    "label": {
        "back": "transparent",
        "text_back": "#000000",
    },

    "button": {
        "radius": 0,
        "back": "#eeeeee",
        "border": "#cccccc",
        "text_back": "#000000",
        "border_width": 1,

        "active": {
            "back": "#666666",
            "border": "#666666",
            "text_back": "#ffffff",
            "border_width": 1,
        },

        "pressed": {
            "back": "#333333",
            "border": "#333333",
            "text_back": "#ffffff",
            "border_width": 1,
        },
    },

    "frame": {
        "radius": 0,
        "back": "#ffffff",
        "border": "#bfbfbf",
        "border_width": 2,
    },

    "entry": {
        "radius": 0,
        "padding": (3, 3),

        "back": "#ffffff",
        "border": "#999999",
        "text_back": "#000000",
        "border_width": 1,

        "bottom_line": "#ffffff",
        "bottom_width": 0,

        "focusin": {
            "back": "#ffffff",
            "border": "#00aedb",
            "text_back": "#000000",
            "border_width": 1,

            "bottom_line": "#ffffff",
            "bottom_width": 0,
        }
    },

    "text": {
        "radius": 0,
        "padding": (3, 3),

        "back": "#ffffff",
        "border": "#999999",
        "text_back": "#000000",
        "border_width": 1,

        "bottom_line": "#ffffff",
        "bottom_width": 0,

        "focusin": {
            "back": "#ffffff",
            "border": "#00aedb",
            "text_back": "#000000",
            "border_width": 1,

            "bottom_line": "#ffffff",
            "bottom_width": 0,
        }
    },

    "separator": {
        "back": "#999999",
        "border_width": 1,

        "rounded": True
    }
}

metro_dark_theme = {
    "window": {
        "back": "#111111"
    },

    "label": {
        "back": "transparent",
        "text_back": "#000000",
    },

    "button": {
        "radius": 0,
        "back": "#222222",
        "border": "#444444",
        "text_back": "#ffffff",
        "border_width": 1,

        "active": {
            "back": "#aaaaaa",
            "border": "#aaaaaa",
            "text_back": "#000000",
            "border_width": 1,
        },

        "pressed": {
            "back": "#eeeeee",
            "border": "#eeeeee",
            "text_back": "#000000",
            "border_width": 1,
        },
    },

    "frame": {
        "radius": 0,
        "back": "#111111",
        "border": "#373737",
        "border_width": 2,
    },

    "entry": {
        "radius": 0,
        "padding": (3, 3),

        "back": "#111111",
        "border": "#999999",
        "text_back": "#ffffff",
        "border_width": 1,

        "bottom_line": "#000000",
        "bottom_width": 0,

        "focusin": {
            "back": "#111111",
            "border": "#00aedb",
            "text_back": "#ffffff",
            "border_width": 1,

            "bottom_line": "#000000",
            "bottom_width": 0,
        }
    },

    "text": {
        "radius": 0,
        "padding": (3, 3),

        "back": "#111111",
        "border": "#999999",
        "text_back": "#ffffff",
        "border_width": 1,

        "bottom_line": "#000000",
        "bottom_width": 0,

        "focusin": {
            "back": "#111111",
            "border": "#00aedb",
            "text_back": "#ffffff",
            "border_width": 1,

            "bottom_line": "#000000",
            "bottom_width": 0,
        }
    },

    "separator": {
        "back": "#999999",
        "border_width": 1,

        "rounded": False
    }
}


def get_default_theme():
    from os import environ
    from json import loads
    try:
        return loads(environ["tkAdwite.DefaultTheme"])
    except KeyError:
        return None


def _set_default_theme(theme):
    from os import environ
    from json import dumps
    environ["tkAdwite.DefaultTheme"] = dumps(theme)


def set_default_theme(theme, mode="system"):
    if theme == "win11" or theme == "windows11" or theme == "Windows11" or theme == "Win11":
        if mode.lower() == "system" or mode.lower() == "auto":
            try:
                from darkdetect import isDark
            except ModuleNotFoundError:
                _set_default_theme(win11_theme)
            else:
                if isDark():
                    _set_default_theme(win11_dark_theme)
                else:
                    _set_default_theme(win11_theme)
        elif mode.lower() == "dark":
            _set_default_theme(win11_dark_theme)
        else:
            _set_default_theme(win11_theme)
    elif theme == "gtk" or theme == "Gtk":
        if mode.lower() == "system" or mode.lower() == "auto":
            try:
                from darkdetect import isDark
            except ModuleNotFoundError:
                _set_default_theme(gtk_theme)
            else:
                if isDark():
                    _set_default_theme(gtk_dark_theme)
                else:
                    _set_default_theme(gtk_theme)

        elif mode.lower() == "dark":
            _set_default_theme(gtk_dark_theme)
        else:
            _set_default_theme(gtk_theme)
    elif theme == "bilibili" or theme == "BiliBili":
        if mode.lower() == "system" or mode.lower() == "auto":
            try:
                from darkdetect import isDark
            except ModuleNotFoundError:
                _set_default_theme(bilibili_theme)
            else:
                if isDark():
                    _set_default_theme(bilibili_dark_theme)
                else:
                    _set_default_theme(bilibili_theme)
        elif mode.lower() == "dark":
            _set_default_theme(bilibili_dark_theme)
        else:
            _set_default_theme(bilibili_theme)
    elif theme == "metro" or theme == "Metro":
        if mode.lower() == "system" or mode.lower() == "auto":
            try:
                from darkdetect import isDark
            except ModuleNotFoundError:
                _set_default_theme(metro_theme)
            else:
                if isDark():
                    _set_default_theme(metro_dark_theme)
                else:
                    _set_default_theme(metro_theme)
        elif mode.lower() == "dark":
            _set_default_theme(metro_dark_theme)
        else:
            _set_default_theme(metro_theme)
    else:
        _set_default_theme(theme)


set_default_theme("win11")


from tkadw.windows.widgets.adw import Adw


class Adwite(Adw):
    def set_default_theme(self, theme, _mode="auto"):
        set_default_theme(theme, _mode)
        for widget in self.winfo_children():
            if hasattr(widget, "palette"):
                widget.palette(get_default_theme())
                widget.configure(background=widget.master.cget("bg"))
                widget._draw(None)
        self.palette(get_default_theme())

    def default_palette(self):
        self.palette(get_default_theme())


from tkadw.windows.widgets import AdwLabel


class AdwTLabel(AdwLabel):
    def default_palette(self):
        self.palette(get_default_theme())


from tkadw.windows.canvas.button import AdwDrawRoundButton3


class AdwTButton(AdwDrawRoundButton3):
    def default_palette(self):
        self.palette(get_default_theme())


from tkadw.windows.canvas.entry import AdwDrawRoundEntry3


class AdwTEntry(AdwDrawRoundEntry3):
    def default_palette(self):
        self.palette(get_default_theme())


from tkadw.windows.canvas.textbox import AdwDrawRoundText3


class AdwTText(AdwDrawRoundText3):
    def default_palette(self):
        self.palette(get_default_theme())


from tkadw.windows.canvas.frame import AdwDrawRoundFrame3


class AdwTFrame(AdwDrawRoundFrame3):
    def default_palette(self):
        self.palette(get_default_theme())


from tkadw.windows.canvas.separator import AdwDrawSeparator


class AdwTSeparator(AdwDrawSeparator):
    def default_palette(self):
        self.palette(get_default_theme())


if __name__ == '__main__':
    from darkdetect import isDark

    root = Adwite()
    root.set_default_theme("metro")

    def toggle():
        root.set_default_theme("win11")

    button = AdwTButton(text="AdwTButton", command=toggle)
    button.pack(fill="x", padx=5, pady=5)
    separator = AdwTSeparator()
    separator.pack(fill="x", padx=5, pady=5)
    entry = AdwTEntry(text="AdwTEntry")
    entry.pack(fill="x", padx=5, pady=5)
    text = AdwTText(text="AdwTText")
    text.pack(fill="x", padx=5, pady=5)
    frame = AdwTFrame()
    frame.pack(fill="x", padx=5, pady=5)
    root.mainloop()